



#define MAX_ERR_NUMBER 32000

enum {
	ERR_OUTOFMEMORY=-(MAX_ERR_NUMBER),
	ERR_INDEXOUTOFBOUNDS,
	ERR_UNREACHABLE,
	ERR_NETWORK_COULDNOTRESOLVE,
	ERR_NETWORK_PORTOUTOFRANGE,
	ERR_NETWORK_SOCKETCREATE,
	ERR_NETWORK_CONNECT,
	ERR_NETWORK_NOTCONNECTED,
	ERR_NETWORK_READERROR,
	ERR_NETWORK_SENDERROR,
	ERR_PROTO_MALFORMEDRESPONSE,
	ERR_DATA_NONSENSE,
	ERR_DATA_INVALIDTOKEN
};




#ifdef THIS_IS_ERRORS_DOT_C

	char *error_lookup[]= {
		"Out of memory",
		"Index out of bounds",
		"\"Unreachable\" code reached!!",
		"Could not resolve address",
		"Supplied port is not a valid port number (0-65535)",
		"Could not create a socket",
		"Could not connect to remote server",
		"A network command was issued, but there is no current connection",
		"A network error occurred while trying to read data from the game socket",
		"A network error occurred while trying to send data to the game socket",
		"A malformed server response was received",
		"Well formed, but non sensical data was received from the server",
		"An invalid token was returned in the data stream"
	};
#else

	extern char *error_lookup[];

#endif


#define SUCCESS(a) (a<0)?0:1
#define FAILURE(a) (a<0)?1:0


	/* Functions */

char *GetErrorString(int error_number);
