



enum {
	MAPTILE_EMPTY=0,
	MAPTILE_BASE,
	MAPTILE_WALL,
	MAPTILE_WATER
};


typedef struct {
	int width,height;
	unsigned char *data;
} _mapinfo;


typedef struct {
	int width,height;
	unsigned int *data;
} _mapinfo_uint;


typedef struct {
	int x,y;
} location;



typedef struct st_ll_maplist_uint {
	int x,y;
	int referencecount;
	int lastturn;
	_mapinfo_uint *map;
	struct st_ll_maplist_uint *next,*prev;
} ll_maplist_uint;

/* Functions */

int map_InitializeMap(mapdata *md);
int map_PrintMapData(mapdata *map);
int map_WeightedDistanceBetween(int fx,int fy,int tx,int ty);
int map_DirectionNextStepBetween(int fx,int fy,int tx,int ty);
int map_IsWater(int x,int y);
inline int map_GetTile(int x,int y);
int map_IsDangerous(int x,int y);

int maplist_ForceMap(_mapinfo_uint **mdata,int dx,int dy);
int maplist_ForcePermMap(_mapinfo_uint **mdata,int dx,int dy);
int maplist_AddMap(_mapinfo_uint **mdata,int dx,int dy,int perm);
int maplist_RemoveMap(int dx,int dy);


int map_PrintDistanceMap(_mapinfo_uint *dmap);
int map_PrintAnsiMap(void);


