


enum {
	CMD_RCV_MOVE=1,
	CMD_RCV_POS,
	CMD_RCV_PICK,
	CMD_RCV_DROP
};

enum {
	CMD_SND_MOVE=1,
	CMD_SND_PICK,
	CMD_SND_DROP,
	CMD_SND_IDLE
};

enum {
	DIRECTION_N=1,
	DIRECTION_E,
	DIRECTION_S,
	DIRECTION_W,
	DIRECTION_NONE
};

typedef struct st_ll_rcvlist {
	int playernum;
	int command;
	int op1,op2;
	struct st_ll_rcvlist *next;
} ll_rcvlist;

typedef struct st_ll_oplist {
	int op;
	struct st_ll_oplist *next;
} ll_oplist;

typedef struct {
	int bid;
	int command;
	ll_oplist *ops;
} sendcommand;
	


typedef struct st_ll_rowdata {
	unsigned int rownumber;
	unsigned char *rowdata;
	struct st_ll_rowdata *next;
} ll_rowdata;


typedef struct {
	int width,height;
	ll_rowdata *rows;
} mapdata;


typedef struct {
	int playernum;
	int maxweight;
	int bidleft;
} init_stats;


typedef struct st_ll_packagelist {
	int packageid;
	int x,y;
	int weight;
	struct st_ll_packagelist *next;
} ll_packagelist;

int proto_sendhello(void);
int proto_receiveboard(mapdata *data);
int proto_receivestats(init_stats *data);
int proto_sendcommand(sendcommand *cmd);
int proto_receivecommands(ll_rcvlist **rlist);
int proto_receivepackages(ll_packagelist **data);








